"use strict";

var _codemirror = _interopRequireDefault(require("codemirror"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function codeMirrorBinder(config) {
  var instance;
  var changeCallback;
  return {
    on: function on(callback) {
      changeCallback = callback;
      instance.on('change', changeCallback);
    },
    getValue: function getValue() {
      instance.save();
      return instance.getValue();
    },
    setValue: function setValue(value) {
      instance.setValue(value);
      instance.save();
    },
    initialize: function initialize() {
      /* istanbul ignore if */
      if (!this.parentNode) {
        throw new Error('parentNode isn\'n found' + ' you need to insert textarea into the document before binder use');
      }

      instance = _codemirror.default.fromTextArea(this, config);
    },
    destroy: function destroy() {
      instance.off('change', changeCallback);
      instance.toTextArea();
    }
  };
}

module.exports = codeMirrorBinder;
